% This code solve and simulate the decision rules of the linearized system of 
% Chen and Song (2013), "Financial Friction on Capital Allocation, A Transmisison Mechanism of TFP Fluctuations"
% To run this code you need the toolkit of Uhlig (1998)

clear
load parameter
load data_ss

% additional parameter
sigma_eps=0.838; %0.843%0.846; 0.85; % Standard deviation of technology shock.  Units: Percent.

%intermediate coefficient
c_52=y_ss^(1-mu1)*the_ss*k_e_ss^(alp*mu1)*n_e_ss^((1-alp)*mu1)*alp*mu1-(r_ss+del)*k_e_ss;
c_54=y_ss^(1-mu1)*the_ss*k_e_ss^(alp*mu1)*n_e_ss^((1-alp)*mu1)*(1-alp)*mu1-w_ss*n_e_ss;
c_56=y_ss^(1-mu1)*the_ss*k_e_ss^(alp*mu1)*n_e_ss^((1-alp)*mu1)*(1-mu1);
c_81=(1-eta)*z_ss*k_h_ss^(alp*mu1)*n_h_ss^((1-alp)*mu1)*alp*mu1/y_ss^mu1;
c_82=eta*the_ss*k_e_ss^(alp*mu1)*n_e_ss^((1-alp)*mu1)*alp*mu1/y_ss^mu1;
c_83=(1-eta)*z_ss*k_h_ss^(alp*mu1)*n_h_ss^((1-alp)*mu1)*(1-alp)*mu1/y_ss^mu1;
c_84=eta*the_ss*k_e_ss^(alp*mu1)*n_e_ss^((1-alp)*mu1)*(1-alp)*mu1/y_ss^mu1;
c_102=alp*k_e_ss^alp;
c_1012=-theta*(1+gg)*(1+nn)*bet_max*theta*v_ss;
c_179=-(1-(1-alp)*mu1)*r_ss/(r_ss+del);
c_232=alp*mu1*y_ss^(1-mu1)*the_ss*k_e_ss^(alp*mu1)*n_e_ss^((1-alp)*mu1)*alp*mu1-(r_ss+q_ss*del)*k_e_ss-alp*mu_ss*k_e_ss^alp*c_e_ss*alp;
c_234=alp*mu1*y_ss^(1-mu1)*the_ss*k_e_ss^(alp*mu1)*n_e_ss^((1-alp)*mu1)*(1-alp)*mu1;
c_236=alp*mu1*y_ss^(1-mu1)*the_ss*k_e_ss^(alp*mu1)*n_e_ss^((1-alp)*mu1)*(1-mu1);
c_23ce=-alp*mu_ss*k_e_ss^alp*c_e_ss;

a_23mu=-alp*mu_ss*k_e_ss^alp*c_e_ss;

d_51=y_ss^(1-mu1)*the_ss*k_e_ss^(alp*mu1)*n_e_ss^((1-alp)*mu1);
d_231=alp*mu1*y_ss^(1-mu1)*the_ss*k_e_ss^(alp*mu1)*n_e_ss^((1-alp)*mu1);

j_25=phi*n_ss^(1+nu1)/(c_w_ss-phi*n_ss^(1+nu1)/(1+nu1));
j_211=-c_w_ss/(c_w_ss-phi*n_ss^(1+nu1)/(1+nu1));
j_419=bet_min/((1+gg)*c_e_ss)+mu_ss*bet_max;

f_53=bet_max*q_ss*kapa/(1+gg)*((1+gg)*(1+nn))^3;
g_53=-(bet_max*q_ss*kapa/(1+gg)*((1+gg)*(1+nn))^3+kapa*((1+gg)*(1+nn))^2);
g_64=-bet_max*(1+gg)*(1+nn)*a_e_ss;
h_53=kapa*((1+gg)*(1+nn))^2;

k_62=alp*k_e_ss^alp;
k_611=-theta*(1+gg)*(1+nn)*bet_max*theta*v_ss;

VARNAMES = ['capital     ',
            'TFP         ',
            'investment  ',
            'asset_e     ',
            'asset_h     ',
            'asset_w     ',
            'mu          ',
            'value l     ',
            'capital h   ',
            'capital e   ',
            'labor h     ',
            'labor e     ',
            'tot. hours  ',
            'tot. output ',
            'profit e    ',
            'interest    ',
            'wage        ',
            'hh con.     ',
            'E_t(value l)',
            'profit h    ',
            'tot. con    ',
            'reallocation',
            'capital l   ',
            'labor l     ',
            'profit l    ',
            'q           ',
            'con. h      ',
            'con. e      ',
            'tfpr ratio  ',
            'tech eff    ',
            'technology  ',
            'News        ']
 %[k(t+1)            tfp(t)      inv(t)  a_e(t+1)                    a_h(t+1)            a_w(t+1)                        mu(t)        v_l(t)] 
 AA=[0                  0              0        0                       0                       0                               0       0
     0                  0              0        0                       0                       0                               0       0
     0                  0              0        0                       0                       0                               0       0
     0                  0              0        0                       0                       0                               0       0
     0                  0              0        0                       0                       0                               0       0
     0                  0              0        0                       0                       0                               0       0
     0                  0              0        0                       0                    -(1+gg)*(1+nn)*a_w_ss*q_ss         0       0
     0                  0              0        0                       0                       0                               0       0
     0                  0              0        0                       0                       0                               0       0
     0                  0              0        0                       0                       0                               0       0
     0                  0              0        0                       0                       0                               0       0
     0                  -1             0        0                       0                       0                               0       0
     (1+gg)*(1+nn)      0     -i_ss/k_ss        0                       0                       0                               0       0
     0                  1              0        0                       0                       0                               0       0
     0                  0              0        0                       0                       0                               0       -1
     0                  0              0        0                       0                       0                               0       0
     0                  0              0        0                       0                       0                               0       0
     0                  0              0        0                       0                       0                               0       0
     0                  0              0   -a_e_ss*(1+gg)*(1+nn)        0                       0                               0       0
     0                  0              0        0                 -a_h_ss*q_ss*(1+gg)*(1+nn)    0                               0       0
     k_ss               0              0        -eta*a_e_ss             -(1-eta)*a_h_ss         -a_w_ss                         0       0
     0                  0              0        0                       0                       0                               a_23mu  0
     0                  0              0        0                       0                       0                               0       0
     0                  0              0        0                       0                       0                               0       0];
  
 %  [k(t)            tfp(t-1)]      inv(t-1)  a_e(t)        a_h(t)                  a_w(t)                  mu(t-1)  v_l(t-1)] 
 BB=[0                  0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0
     -1                 0               0       0               0                   0                       0           0
     (r_ss+del)*k_ss    0               0       0               0                   a_w_ss*(q_ss+r_ss)      0           0
     0                  0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0
     -alp               0               0       0               0                   0                       0           0
     -(1-del)           0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0
     0                  0               0 a_e_ss*(q_ss+r_ss)    0                   0                       0           0
     0                  0               0       0               a_h_ss*(q_ss+r_ss)  0                       0           0
     0                  0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0
     0                  0               0       0               0                   0                       0           0];
 
    %[k_h                   k_e                 n_h            n_e              H           Y           pi_e              r                 w              c_w     EV_l                 pi_h  con   RE k_l           n_l         pi_l              q                         c_h              c_e            TFPR ratio tech] 
 CC=[alp*mu1-1              0                   (1-alp)*mu1     0               0           1-mu1         0                -r_ss/(r_ss+del)   0              0        0                    0      0   0   0            0           0                 -del/(r_ss+del)            0               0              0        0
     alp*mu1                0                   (1-alp)*mu1-1   0               0           1-mu1         0                0                 -1              0        0                    0      0   0   0            0           0                 0                          0               0              0        0
     0                      0                   0               0               nu1         0             0                0                 -1              0        0                    0      0   0   0            0           0                 0                          0               0              0        0
     0                      alp*mu1             0               (1-alp)*mu1-1   0           1-mu1         0                0                 -1              0        0                    0      0   0   0            0           0                 0                          0               0              0        0
     0                      c_52                0               c_54            0           c_56          -prof_e_ss       -r_ss*k_e_ss      -w_ss*n_e_ss    0        0                    0      0   0   0            0           0                 -del*k_e_ss                0               0              0        0
     (1-eta)*k_h_ss/k_ss    eta*k_e_ss/k_ss     0               0               0           0             0                0                 0               0        0                    0      0   0   0            0           0                 0                          0               0              0        0
     0                      0                   0               0               w_ss*n_ss   0             0                r_ss*a_w_ss       w_ss*n_ss       -c_w_ss  0                    0      0   0   0            0           0                 q_ss*i_ss-(gg+nn)*a_w_ss   0               0              0        0
     c_81                   c_82                c_83            c_84            0           -mu1          0                0                 0               0        0                    0      0   0   0            0           0                 0                          0               0              0        0
     0                      0                   (1-eta)*n_h_ss  eta*n_e_ss      -n_ss       0             0                0                 0               0        0                    0      0   0   0            0           0                 0                          0               0              0        0
     alp*mu1                0                   (1-alp)*mu1     0               0           1-mu1         0                0                 0               0        0                    -1     0   0   0            0           0                 0                          0               0              0        0
     0                      0                   0               0               0           0             0                0                 0               c_w_ss   0                    0  -c_ss   0   0            0           0                 0                         (1-eta)*c_h_ss   eta*c_e_ss     0        0
     0                      0                   0               0               -(1-alp)    1             0                0                 0               0        0                     0     0   0   0            0           0                 0                          0               0              0        0
     0                      0                   0               0               0           0             0                0                 0               0        0                     0     0   0   0            0           0                 0                          0               0              0        0
     0                      0                   0               0               0           0             0                0                 0               0        0                     0     0   -1  0            0           0                 0                          0               0              0        0
     0                      0                   0               0               0           0             0                0                 0               0    bet_max*theta*(1+gg)*(1+nn) 0     0   0   0            0    prof_l_ss/v_ss           0                          0               0              0        0
     0                      0                   0               0               0           1-mu1         0                c_179             -(1-alp)*mu1    0        0                     0     0   0   -(1-mu1)     0           0        -(1-(1-alp)*mu1)*del/(r_ss+del)     0               0              0        0
     0                      0                   0               0               0           1-mu1         0        -alp*mu1*r_ss/(r_ss+del)  -(1-alp*mu1)    0        0                     0     0   0   0       -(1-mu1)         0        -alp*mu1*del/(r_ss+del)             0               0              0        0
     0                      0                   0               0               0           1-mu1         0                0                 0               0        0                     0     0   0   alp*mu1  (1-alp)*mu1     -1                0                          0               0              0        0
     0                      0                   0               0               0           0             prof_e_ss        r_ss*a_e_ss       0               0        0                     0     0   0   0            0           0               -q_ss*a_e_ss*(gg+nn)         0               -c_e_ss        0        0
     0                      0                   0               0               0           0             0                r_ss*a_h_ss       0               0        0             prof_h_ss     0   0   0            0           0               -q_ss*a_h_ss*(gg+nn)         -c_h_ss         0              0        0
     0                      0                   0               0               0           0             0                0                 0               0        0                     0     0   0   0            0           0                 0                          0               0              0        0
     0                      c_232               0               c_234           0           c_236         0                -r_ss*k_e_ss      0               0        0                     0     0   0   0            0           0               -q_ss*k_e_ss*del             0               c_23ce         0        0
     1-alp*mu1              alp*mu1-1           -(1-alp)*mu1    (1-alp)*mu1     0           0             0                0                 0               0        0                     0     0   0   0            0           0                 0                          0               0              -1/alp   0
     0                      0                   0               0               0           0             0                0                 0               0        0                     0     0   0   0            0           0                 0                          0               0              0        1];
     
%   [z_t    ]
 DD=[1      0
     1      0
     0      0
     1      0
     d_51   0
     0      0
     0      0
     1      0
     0      0
     1      0
     0      0
     0      0
     0      0
     -1/mu1 0
     0      0
     1      0
     1      0
     1      0
     0      0
     0      0
     0      0
     d_231  0
     0      0
     -1/mu1 0];
 
%k(t+2) tfp(t+1) i(t+1) a_e(t+2) a_h(t+2) a_w(t+2)  mu(t+1) v_l(t+1)
 FF=[0      0    0      0           0       0       0          -1
     0      0    0      0           0       0       0           0
     0      0    0      0           0       0       0           0
     0      0    0      0           0       0       0           0
     0      0    f_53   0           0       0       0           0
     0      0    0      0           0       0       0           0];
% k(t+1) tfp(t) i(t) a_e(t+1) a_h(t+1) a_w(t+1)     mu(t)   v_l(t)
 GG=[0      0    0      0       0       0           0           0
     0      0    0      0       0       0           0           0
     0      0    0      0       0       0           0           0
     0      0    0      0       0       0   mu_ss*bet_max       0
     0      0    g_53   0       0       0           0           0
     0      0    0      g_64    0       0           0           0];
% k(t) tfp(t-1) i(t-1) a_e(t) a_h(t) a_w(t)         mu(t-1)  v_l(t-1)
 
 HH=[0  0         0     0       0       0           0           0
     0  0         0     0       0       0           0           0
     0  0         0     0       0       0           0           0
     0  0         0     0       0       0           0           0
     0  0         h_53  0       0       0           0           0
     0  0         0     0       0       0           0           0];

  %[k_h k_e h_h h_h H       Y                    pi_e  r                           w     c_w     EV_l  pi_h con  RE     k_l           n_l         pi_l       q                      c_h            c_e                          TFPR ratio tech]

 JJ=[0  0   0   0   0       0                     0    0                           0     0        0     0    0    0       0             0           0         0                      0               0                             0        0       
     0  0   0   0   j_25    0                     0   r_ss/(1+r_ss)                0     j_211    0     0    0    0       0             0           0  q_ss/(q_ss+r_ss)              0               0                             0        0
     0  0   0   0   0       0                     0   r_ss/(1+r_ss)                0     0        0     0    0    0       0             0           0  q_ss/(q_ss+r_ss)              -1              0                             0        0
     0  0   0   0   0       0                     0   bet_min*r_ss/((1+gg)*c_e_ss) 0     0        0     0    0    0       0             0           0        j_419                   0   -bet_min*(q_ss+r_ss)/((1+gg)*c_e_ss)      0        0
     0  0   0   0   0       0                     0    0                           0     0        0     0    0    0       0             0           0        0                       0               0                             0        0
     0  0   0   0   0       0                     0    0                           0     0        0     0    0    0       0             0           0 -bet_max*(1+gg)*(1+nn)*a_e_ss  0               0                             0        0];
  %[k_h k_e    h_h h_h          H       Y    pi_e                 r    w  c_w      EV_l pi_h con RE    k_l  n_l         pi_l       q      c_h              c_e           TFPR ratio tech]
 
 KK=[0  0       0   0           0       0      0                  0    0   0         1   0   0   0      0    0           0         0       0                0                0       0
     0  0       0   0           -j_25   0      0                  0    0   -j_211    0   0   0   0      0    0           0         -1      0                0                0       0
     0  0       0   0           0       0      0                  0    0   0         0   0   0   0      0    0           0         -1      1                0                0       0
     0  0       0   0           0       0      0                  0    0   0         0   0   0   0      0    0           0   -1/c_e_ss     0                1/c_e_ss         0       0
     0  0       0   0           0       0      0                  0    0   0         0   0   0   0      0    0           0         1       0                0                0       0
     0  k_62    0   0           0       0      0                  0    0   0     k_611   0   0   0      0    0           0         0       0                0                0       0];
 
 LL=[0  0
     0  0
     0  0
     0  0
     0  0
     0  0];
 
 MM=[0  0
     0  0
     0  0
     0  0
     0  0
     0  0];
 
 NN=[p_h    1
     0      0];
 
 Sigma = [sigma_eps^2   0
          0             sigma_eps^2];
 % Setting the options:
  
[l_equ,m_states] = size(AA);
[l_equ,n_endog ] = size(CC);
[l_equ,k_exog  ] = size(DD);

PERIOD     = 1;  % number of periods per year, i.e. 12 for monthly, 4 for quarterly
GNP_INDEX  = 14; % Index of output among the variables selected for HP filter
% IMP_SELECT = [4,9, 19, 26];
IMP_SELECT = [2, 22,30];
% IMP_SELECT = [4,5,8,26];
IMP_SUBPLOT= 1;
DO_SIMUL   = 1; % Calculates simulations

SIM_LENGTH = 47;
SIM_N_SERIES = 500;     %number of simulated series for the calculations of moments.

DO_MOMENTS = 1; % Calculates moments based on frequency-domain methods
DISPLAY_IMMEDIATELY = 1;
HP_LAMBDA=100;

   %  a vector containing the indices of the variables to be plotted
HP_SELECT  = 1:(m_states+n_endog+k_exog); % Selecting the variables for the HP Filter calcs.

DO_STATE_RESP = 0;     % = 1, if impulse responses to deviations of state
INIT_DATE = 1;         % Number of periods prior to shock.  Default = 4.
%                      % For INIT_DATE = 1, one sees the inital value for the state variable.
%                      % For INIT_DATE > 0, variables are initially zero, before responding.
HORIZON      = 10;     % how far out should the impulse responses be calculated

%AXIS_SCALE = [0,HORIZON,0,5];
SAVE_FIG   = 1;        % Set = 1, if you want to save figures as encapsulated postscript files.
%                      % The graphic names are automatically chosen.  E.g. for impulse responses,
%                      % the file names are imprespN.eps, where N = 1,2,...  .  
%                      % Note: you need to set PRINT_FIG = 0 to be able to use SAVE_FIG.
FILENAMEPIECE = '_tfp_';    % To change the naming of the impulse response files from e.g.
%                      % impresp1.eps to impresp_new_1.eps,
%                      % assign FILENAMEPIECE='_new_'.

SIM_GRAPH = 0;         % Set to = 1 to see plots of the simulated series. 
DO_HP_GRAPH=0;         % To plot spectral densities

DO_SCALE_AXIS = 0;
DO_GIVEN_AXIS_SCALE = 1;
AXIS_SCALE = [-1,HORIZON-1,0,2];

% Starting the calculations:

do_it;

