% this code is the subcode to solve the steady state of the benchmark model
% of Chen and Song (2013), "Financial Friction on Capital Allocation, A Transmisison Mechanism of TFP Fluctuations"


function y=fun_ss_benchmark(x)

load parameter


% unknowns
k_h_ss=x(1);
y_ss=x(2);


% variables
r_ss=(1+gg)/bet_max-1; % interest rate
n_h_ss=(k_h_ss^(1-alp*mu1)*(r_ss+del)/(y_ss^(1-mu1)*alp*mu1*z_ss))^(1/((1-alp)*mu1));
w_ss=y_ss^(1-mu1)*(1-alp)*mu1*z_ss*k_h_ss^(alp*mu1)*n_h_ss^((1-alp)*mu1-1); % wage rate
n_ss=(w_ss/phi)^(1/nu1);
n_e_ss=(n_ss-(1-eta)*n_h_ss)/eta;
k_e_ss=(w_ss*n_e_ss^(1-(1-alp)*mu1)/((1-alp)*mu1*y_ss^(1-mu1)*the_ss))^(1/(alp*mu1));
prof_h_ss=y_ss^(1-mu1)*z_ss*(k_h_ss^alp*n_h_ss^(1-alp))^mu1-(r_ss+del)*k_h_ss-w_ss*n_h_ss; % profit in the traditional sector
prof_e_ss=y_ss^(1-mu1)*the_ss*(k_e_ss^alp*n_e_ss^(1-alp))^mu1-(r_ss+del)*k_e_ss-w_ss*n_e_ss; % profit in the modern sector
k_ss=(1-eta)*k_h_ss+eta*k_e_ss;
i_ss=(del+gg+nn)*k_ss; % new capital installed
k_l_ss=(mu1*y_ss^(1-mu1)*z_ss*((1-alp)/w_ss)^((1-alp)*mu1)*(alp/(r_ss+del))^(1-(1-alp)*mu1))^(1/(1-mu1));
n_l_ss=(mu1*y_ss^(1-mu1)*z_ss*((1-alp)/w_ss)^(1-alp*mu1)*(alp/(r_ss+del))^(alp*mu1))^(1/(1-mu1));
prof_l_ss=(1-mu1)*y_ss^(1-mu1)*z_ss*(k_l_ss^alp*n_l_ss^(1-alp))^mu1;
v_ss=prof_l_ss/(1/(bet_max*theta*(1+gg)*(1+nn))-1);
a_e_ss=(k_e_ss^alp-theta*v_ss)/(ps1*bet_max*(1+gg)*(1+nn));
c_e_ss=prof_e_ss+(r_ss-gg-nn)*a_e_ss;
lam_e_ss=1/c_e_ss;
mu_ss=lam_e_ss*(alp*mu1*y_ss^(1-mu1)*the_ss*(k_e_ss^alp*n_e_ss^(1-alp))^mu1-(r_ss+del)*k_e_ss)/(alp*k_e_ss^alp);
mu1_ss=lam_e_ss*(1-bet_min/bet_max)/(ps1*bet_max);
a_h_ss=(k_h_ss^alp-theta*v_ss)/(ps1*bet_max*(1+gg+nn));
c_h_ss=prof_h_ss+(r_ss-gg-nn)*a_h_ss;

% two equations to check
y(1)=y_ss-((1-eta)*z_ss*(k_h_ss^alp*n_h_ss^(1-alp))^mu1+eta*(the_ss*(k_e_ss^alp*n_e_ss^(1-alp))^mu1))^(1/mu1);
y(2)=mu_ss-mu1_ss;

xxx=1;